/*=============================================================================
	CoolBits.h: CoolBits general header file.
	If you like it, gift me Lego.

	Revision history:
		* Created by Sebastian Kaufel
=============================================================================*/

#ifndef _COOLBITS_H
#define _COOLBITS_H

#if _MSC_VER
#pragma pack (push,4)
#endif

#ifndef COOLBITS_API
#define COOLBITS_API DLL_IMPORT
#endif

#ifndef NAMES_ONLY
#define AUTOGENERATE_NAME(name) extern COOLBITS_API FName COOLBITS_##name;
#define AUTOGENERATE_FUNCTION(cls,idx,name)
#endif

/*-----------------------------------------------------------------------------
	Class definitions.
-----------------------------------------------------------------------------*/

#ifndef NAMES_ONLY

class COOLBITS_API CCoolBits : public UObject
{
public:
	DECLARE_CLASS(CCoolBits,UObject,0)
	NO_DEFAULT_CONSTRUCTOR(CCoolBits)

	// Variables.
	FName CoolBitsVersion;

	// UI Scale fix.
	void PreRender( XRootWindow* RootWindow, UCanvas* Canvas, INT Scale );
	void PostRender( XRootWindow* RootWindow, UCanvas* Canvas, INT Scale );
	void ResizeRoot( XRootWindow* RootWindow, UCanvas* Canvas, INT Scale );

	// TraceTexture fix.
	INT FindNode( UModel* Model, INT iPlane, FVector Point );

	// Things getting badass.
	void ExportTravel( FStringOutputDevice& Out, UObject* RootObject );

	DECLARE_FUNCTION(execPreRenderWindows);
	DECLARE_FUNCTION(execPostRenderWindows);
	DECLARE_FUNCTION(execTraceTextureCoolBits);
	DECLARE_FUNCTION(execStriHash);
	DECLARE_FUNCTION(execBindConversationList);
	DECLARE_FUNCTION(execExportTravel);
};

AUTOGENERATE_FUNCTION(CCoolBits,4004,execPreRenderWindows);
AUTOGENERATE_FUNCTION(CCoolBits,4005,execPostRenderWindows);
AUTOGENERATE_FUNCTION(CCoolBits,4006,execTraceTextureCoolBits);
AUTOGENERATE_FUNCTION(CCoolBits,4007,execStriHash);
AUTOGENERATE_FUNCTION(CCoolBits,4008,execBindConversationList);
AUTOGENERATE_FUNCTION(CCoolBits,4009,execExportTravel);

#endif

/*-----------------------------------------------------------------------------
	Names.
-----------------------------------------------------------------------------*/

#ifndef NAMES_ONLY
#undef AUTOGENERATE_NAME
#undef AUTOGENERATE_FUNCTION
#endif NAMES_ONLY

#if _MSC_VER
#pragma pack (pop)
#endif

#endif

/*-----------------------------------------------------------------------------
	The End.
-----------------------------------------------------------------------------*/
